/*///+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
/*///+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
//+------------------------------------------------------------------+
//|                                                    RENCO_iMA.mq4 |
//|                                                            Urain |
//+------------------------------------------------------------------+
#property copyright "Urain"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_color2 Yellow

extern int  dig =20;//---- input parameters
//extern int       spred=8;
extern int per  =8;
extern int por  =5;
extern int met1 =1;
extern int met2 =1;

double e0[];       //---- buffers 0
double Sig[];      //---- buffers 1

int  i,j,N=0,sN=0,psN=0,mo,bBars=1, lim;
double  fat[],f[],levO;
bool _=1;int start_;
//+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+

int init()
{//+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,e0);
   SetIndexShift(0,-1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,Sig);
   
   levO=Close[Bars-1];
   mo=MO( Close,Bars,-1);
   start_=GetTickCount();
   ArrayResize(f,Bars);
   sN = QUANTUM_rev( f, Close, dig, Bars-2, 1);
   ArrayResize(f,sN);
   levO=f[sN-1];
   bBars=Bars;
return(0);
}//+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+

int start()
{//+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
 if(bBars!=Bars||_)//Bars//+~~~~~~~~~~~~~~~~~~~~~~~~~+
   {lim=Bars-bBars; bBars=Bars; 
    if(lim>0 && !_)
      {start_=GetTickCount();
       for( i=lim-1;i>0;i--)
          {ArrayResize(fat,Bars);
           double Cl=Close[i];
           N = RENCO( fat, dig, levO, Cl);
           if(N!=0)
             {ArrayResize(fat,N);
              psN=sN; sN+=N; ArrayResize(f,sN);
              for( j= psN;j<sN;j++) f[j]=fat[j-psN];
             }
          }     
       }
     _=0;  
     SetIndexDrawBegin( 0, Bars-sN);
     for( i=0;i<sN;i++){e0[i]=f[sN-i-1];}
     string ISN="[ Bars = "+Bars+" Count = "+sN+"   = "+dig+"  MO = "+mo+" ] ";
     //Comment(ISN);
     IndicatorShortName(ISN);
     Comment("  . ",(GetTickCount()-start_)*0.001," .");
     for(i = sN-per-1;i>0;i--)
        {double tmp1=iMAOnArray( f,0,per,0,met1,i);
         double tmp2=iMAOnArray( f,0,per,1,met2,i);
         if(MathAbs(tmp1-tmp2)>=por*Point) Sig[i]=tmp2;
         else Sig[i]=Sig[i+1]; 
        }          
    }//Bars//+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
  
return(0);
}//+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+


int RENCO( double& fat[], int dig, double& levO, double levC)
{//+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
 double  rz=levC-levO;
 double  Arz=MathAbs(rz);
 double  dP=dig*Point;
 double odP=ox( dP);
 int N=0;
 if(Arz>=dP)
   {N = Arz*odP;
    ArrayResize(fat,N);
    ArrayInitialize(fat,0.0);
    int j=0; double  sum = levO;
    while(j<N)
      {if(rz>0)sum+=dP;
       else    sum-=dP;
       fat[j]= sum;  
       j++;
      }
     levO=sum;  
    }
return(N);
}//+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+


/*///05~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*///05~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int QUANTUM_rev( double& vih[], double vh[], int dig,int cou,int o)
{//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 double dd= dig;
 double mp=MathPow(10.0,Digits);
 double co,cc,a,sum;
 int i,C=1,n;
 bool z;
 co=vh[cou];
 vih[cou]=co;
 for( i=cou-1;i>=o;i--)//~~~~~~~~~~~~~~~~~~~~~~
    {cc=vh[i];
     z=zn( cc-co);
     a=MathAbs( cc-co)*mp; 
     if(a >= dd)//~~~~~~~~~~~~~~~~~~ 
       {n= a/dd;
        sum=co;int j=0;
        while(j<n)//~~~~~~~~~
          {if(z)sum+=dd/mp;
           else sum-=dd/mp;
           vih[C]=sum;
           j++;
           C++;
          }//~~~~~~~~~~~~~~~~
        co=sum;
       }//~~~~~~~~~~~~~~~~~~~~~~~~~~
    }//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    /*
 for( i=1;i<=C/2;i++)//~~~~~~~~~~~~~~~~~~~~~~
    { double temp= vih[C-i];
      vih[C-i]= vih[i];
      vih[  i]= temp;
    }//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    */
return(C);
}//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

/*///01~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*///01~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
double ox( double x)
{//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 double y=0;
 if(x!=0.0) y=1.0/x; 
 else y= 1.0/MathPow(10.0,300);
return(y);
}//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


/*///03~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*///03~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool zn( double x)
{//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 bool z=true;
 if(x<0.0) z=false; 
return(z);
}//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


/*///02~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*///02~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
double MO( double e[],int c,double moq)
{//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 double sum=0.0, cnt=0.0;int i;
 double mp=MathPow(10.0,Digits);
 for( i=0;i<c-1;i++)
    {double nen=MathAbs(e[i]-e[i+1]);
     if(moq<nen)sum+= nen*mp;
    }
 cnt=ox( c);  
 sum*=cnt;
return(NormalizeDouble(sum,0)+1);
}//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



